#!/usr/bin/python

from jinja2 import Template

import argparse
import sys, os

TPL_FILE = "index.tpl"

if __name__ == '__main__':
    parser = argparse.ArgumentParser(description='Generate status page.')
    parser.add_argument('--status', type=str, default="UNKNOWN", help='The meter status.', choices=['UNKNOWN', 'GREEN', 'AMBER', 'RED'])
    parser.add_argument('--info', type=str, default="", help='Additional meter information.')
    parser.add_argument('--destination', '-d', type=str, required=True, help='File to write result to.')
    parser.add_argument('extra', type=str, nargs='*', help='Additional data to display, must be formed as key=value.')
    args = parser.parse_args()

    template_data = ""
    template_file = os.path.join(os.path.dirname(os.path.abspath(sys.argv[0])), TPL_FILE)
    with open(template_file) as f:
        template_data = f.read()

    data = {
        'status': args.status,
        'info': args.info,
        'extra': {}
    }

    for item in args.extra:
        if not "=" in item:
            continue
        key, value = item.split("=", 2)
        data['extra'][key]=value

    template = Template(template_data)
    with open(args.destination, 'w') as f:
        f.write(template.render(**data))
